//+------------------------------------------------------------------+
//|                                                                  |
//|                                                        FX Sniper |
//| Original Code by FX Sniper and just changed a little by Linuxser |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "FX Sniper:  T3-atr :-)"
#property link      "http://dunno.com  :-)/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1   Aqua 
#property  indicator_color2  LimeGreen
#property  indicator_color3  Red
//----
extern int    ATR_Period = 14;
extern int    T3_Period  = 5;
extern double b          = 1.00;
extern bool   Histogram  = false;
//----
double atr[];
double atrHup[];
double atrHdn[];

double emas[][6];
double alpha;
double c1;
double c2;
double c3;
double c4;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
    SetIndexBuffer(0, atr);
    SetIndexBuffer(1, atrHup);
    SetIndexBuffer(2, atrHdn);
//----
    SetIndexStyle(0, DRAW_LINE);
    SetIndexStyle(1, DRAW_HISTOGRAM);
    SetIndexStyle(2, DRAW_HISTOGRAM); 
//----        
    IndicatorShortName("ATR T3(" + ATR_Period + ", " + T3_Period + ")");
    SetIndexLabel(0, "T3ATR");     
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);   
//---- variable reset
   //
   //
   //
   //
   //
   
      double a  = b;
             c1 = -a*a*a;
             c2 =  3*(a*a+a*a*a);
             c3 = -3*(2*a*a+a+a*a*a);
             c4 = 1+3*a+a*a*a+3*a*a;

      T3_Period = MathMax(1,T3_Period);
      alpha = 2.0/(2.0 + (T3_Period-1.0)/2.0);

    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   int    pos,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
          
   //
   //
   //
   //
   //
   
   for(int i = limit; i >= 0; i--)
     {   
       atr[i] = iT3(iATR(NULL,0,ATR_Period,i),i);
       if(Histogram == true)
       {
         if(atr[i] >= 0) atrHup[i] = atr[i];
         else            atrHup[i] = 0;   
         if(atr[i] < 0 ) atrHdn[i] = atr[i];
         else            atrHdn[i] = 0; 
       }    
     }   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iT3(double price,int shift)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0] = price;
         emas[i][1] = price;
         emas[i][2] = price;
         emas[i][3] = price;
         emas[i][4] = price;
         emas[i][5] = price;
      }
   else
      {
         emas[i][0] = emas[i-1][0]+alpha*(price     -emas[i-1][0]);
         emas[i][1] = emas[i-1][1]+alpha*(emas[i][0]-emas[i-1][1]);
         emas[i][2] = emas[i-1][2]+alpha*(emas[i][1]-emas[i-1][2]);
         emas[i][3] = emas[i-1][3]+alpha*(emas[i][2]-emas[i-1][3]);
         emas[i][4] = emas[i-1][4]+alpha*(emas[i][3]-emas[i-1][4]);
         emas[i][5] = emas[i-1][5]+alpha*(emas[i][4]-emas[i-1][5]);
      }
   return(c1*emas[i][5] + c2*emas[i][4] + c3*emas[i][3] + c4*emas[i][2]);
}